---
title: Path2D
slug: Web/API/Path2D
tags:
  - API
  - Canvas
  - Interface
  - Path2D
  - Reference
---
<div>{{APIRef("Canvas API")}} {{SeeCompatTable}}</div>

<p>The <strong><code>Path2D</code></strong> interface of the Canvas 2D API is used to declare a path that can then be used on a {{domxref("CanvasRenderingContext2D")}} object. The<a href="/en-US/docs/Web/API/CanvasRenderingContext2D#Paths"> path methods</a> of the <code>CanvasRenderingContext2D</code> interface are also present on this interface, which gives you the convenience of being able to retain and replay your path whenever desired.</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref("Path2D.Path2D", "Path2D()")}}</dt>
 <dd><code>Path2D</code> constructor. Creates a new <code>Path2D</code> object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("Path2D.addPath()")}}</dt>
 <dd>Adds a path to the current path.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.closePath", "Path2D.closePath()")}}</dt>
 <dd>Causes the point of the pen to move back to the start of the current sub-path. It tries to draw a straight line from the current point to the start. If the shape has already been closed or has only one point, this function does nothing.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.moveTo()", "Path2D.moveTo()")}}</dt>
 <dd>Moves the starting point of a new sub-path to the (<code>x, y</code>) coordinates.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.lineTo()", "Path2D.lineTo()")}}</dt>
 <dd>Connects the last point in the subpath to the (<code>x, y</code>) coordinates with a straight line.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.bezierCurveTo()", "Path2D.bezierCurveTo()")}}</dt>
 <dd>Adds a cubic Bézier curve to the path. It requires three points. The first two points are control points and the third one is the end point. The starting point is the last point in the current path, which can be changed using <code>moveTo()</code> before creating the Bézier curve.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.quadraticCurveTo()", "Path2D.quadraticCurveTo()")}}</dt>
 <dd>Adds a quadratic Bézier curve to the current path.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.arc()", "Path2D.arc()")}}</dt>
 <dd>Adds an arc to the path which is centered at (<code>x, y</code>) position with radius<em> </em><code>r</code> starting at <code>startAngle</code> and ending at <code>endAngle</code> going in the given direction by <code>anticlockwise</code> (defaulting to clockwise).</dd>
 <dt>{{domxref("CanvasRenderingContext2D.arcTo()", "Path2D.arcTo()")}}</dt>
 <dd>Adds a circular arc to the path with the given control points and radius, connected to the previous point by a straight line.</dd>
 <dt>{{domxref("CanvasRenderingContext2D.ellipse()", "Path2D.ellipse()")}}</dt>
 <dd>Adds an elliptical arc to the path which is centered at (<code>x, y</code>) position with the radii <code>radiusX</code> and <code>radiusY</code> starting at <code>startAngle</code> and ending at <code>endAngle</code> going in the given direction by <code>anticlockwise</code> (defaulting to clockwise).</dd>
 <dt>{{domxref("CanvasRenderingContext2D.rect()", "Path2D.rect()")}}</dt>
 <dd>Creates a path for a rectangle at<em> </em>position (<code>x, y</code>) with a size that is determined by <code>width</code> and <code>height</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#path2d-objects", "Path2D")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Path2D")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasRenderingContext2D")}}</li>
</ul>
